﻿using Hotline.Caching.Interfaces;
using Hotline.Settings.TimeLimits;
using Hotline.Share.Dtos.Settings;
using Hotline.Share.Enums.FlowEngine;
using Hotline.Share.Enums.Settings;
using MapsterMapper;
using System.Runtime.CompilerServices;
using XF.Domain.Dependency;
using XF.Domain.Exceptions;
using XF.Domain.Repository;
using XF.Utility.EnumExtensions;

namespace Hotline.Settings.TimeLimitDomain;

/// <summary>
/// 宜宾过期时间计算
/// </summary>
public class YBExpireTimeLimit : ExpireTimeLimitBase, ICalcExpireTime, IScopeDependency
{
    private readonly ISystemSettingCacheManager _systemSettingCacheManager;
    private readonly IRepository<TimeLimitSetting> _timeLimitSettingRepository;
    private readonly IExpireTimeHandler _expireTimeHandler;
    private readonly IMapper _mapper;
    private readonly IRepository<SystemSetting> _systemSettingRepository;
    private readonly IDaySettingRepository _daySettingRepository;

    public YBExpireTimeLimit(ISystemSettingCacheManager systemSettingCacheManager, IRepository<TimeLimitSetting> timeLimitSettingRepository, IExpireTimeHandler expireTimeHandler, IMapper mapper, IRepository<SystemSetting> systemSettingRepository, IDaySettingRepository daySettingRepository) : base(systemSettingCacheManager, timeLimitSettingRepository, expireTimeHandler, mapper, systemSettingRepository, daySettingRepository)
    {
        _systemSettingCacheManager = systemSettingCacheManager;
        _timeLimitSettingRepository = timeLimitSettingRepository;
        _expireTimeHandler = expireTimeHandler;
        _mapper = mapper;
        _systemSettingRepository = systemSettingRepository;
        _daySettingRepository = daySettingRepository;
    }
}
